package org.greenstone.gsdl3.gs3build.database;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.ResultSet;

public class SQLConnection
{
    protected Connection connection;
    protected Statement  statement;
    protected String database;
    
    public SQLConnection(java.sql.Connection connection, String database)
    { 
	this.connection = connection;
	this.database = database;
    }
    
    protected void finalize() {
	if (this.connection!=null) {
	    try {
		this.connection.close();		
	    } catch (Exception e) {}
	}
	if (this.statement!=null) {
	    try {
		this.statement.close();		
	    } catch (Exception e) {}
	}
	
	this.connection = null;   
	this.statement = null;

    }
    
    public void close() {
	finalize();
    }
	
    public boolean execute(String sql)
    {
	try {
	    if (this.statement != null) {
		this.statement.close();
	    }
	    this.statement = this.connection.createStatement();
	    this.statement.execute(sql);
	}
	catch (SQLException ex) {
	    System.out.println(ex);
	    return false;
	}
	return true;
    }
    
    public void closeStatement() {
	try {
	    if (this.statement != null) {
		this.statement.close();
	    } 
	} catch (Exception e) {}
	    
    }
    public Statement createStatement()
    { 
	try {
	    return this.connection.createStatement();
	}
	catch (SQLException ex) {
	    return null;
	}
    }
    
    public Statement getStatement()
    { 
	return this.statement;
    }
    
    public ResultSet getResultSet()
    { 
	try {
	    return this.statement.getResultSet();
	}
	catch (SQLException ex) {
	    return null;
	}
    }
    
    public boolean connectToDatabase(String database) {
	if (this.connection != null) {
	    try {
		this.connection.close();
	    } catch (Exception e) {}
	}
	this.connection = GS3SQLConnectionFactory.getConnection(database);
	if (this.connection == null) {
	    return false;
	}
	this.database = database;
	return true;
    }
    
    public boolean dropDatabase(String database) {
	try {
	    this.statement = this.connection.createStatement();
	    this.statement.execute("DROP DATABASE "+database+";");
	    this.statement.close();
	}
	catch (SQLException ex){
	    System.err.println(ex);
	    return false;
	}
	return true;
	
    }

    public boolean createDatabase(String database) {
	try {
	    String command = "CREATE DATABASE " + database;
	    this.statement = this.connection.createStatement();
	    this.statement.execute(command);
	    this.statement.close();
	} catch (Exception e) {
	    System.err.println(e);
	    return false;
	}
	 
	return true;
    }

}
